/*
 * Copyright (C) 2002 Ilya Volynets, Total Knowledge
 *
 * This program is free software. Free means freedom.
 * You are hereby granted the right to use this program
 * in any way you want as long as following conditions are met:
 * 1. All source distributions with code unmodified will also retain this
 *    notice intact.
 * 2. All binary distributions will be accompanied by text file clearly
 *    attributing authorship to Ilya Volynets and sopnsorship to
 *    Total Knowledge using following wording:
 *    "This binary is built from sources developed by Ilya Volynets.
 *    Development was kindly sponsored by Total Knowledge"
 * 3. All modified versions, if distributed, will clearly indicate
 *    that they are not original works and that they were derived from
 *    work developed by Ilya Volynets and sponsored by Total Knowledge
 */


#include "ssl++"
#include <openssl/err.h>

int CSSLObject::init_count=0;
SSL_CTX* CSSLObject::ctx=NULL;
CSSLObject::CSSLObject()
{
    if(init_count)
	return;
    SSL_load_error_strings();
    SSL_library_init();
    ctx=SSL_CTX_new(SSLv3_method());
    SSL_CTX_set_options(ctx, SSL_OP_ALL);
    init_count++;
}

void CSSLObject::checkErrors(const std::string& tag)
{
    int i;
    cerr<<tag<<':'<<'\n';
    while((i=ERR_get_error())){
	char buf[1024];
	ERR_error_string_n(i,buf,sizeof(buf));
	cerr<<"\tError "<<i<<": "<<buf<<'\n';
    }
}
